package Alterator::Automate;

use 5.012003;
use HTTP::Request::Common qw(POST);
use LWP::UserAgent;
use strict;
use warnings;
use Carp;

require Exporter;

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use Alterator::Automate ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	
);

our $VERSION = '0.01';

sub new {
	my $class = shift;
	my $host = shift;
	my $ua = LWP::UserAgent->new( ssl_opts => { verify_hostname => 0 } );
	my $self  = { host => $host,
	ua => $ua };
	bless( $self, $class );
}


sub auth{
	my $self = shift;
	my $password = shift;
	my $req = POST "https://$self->{host}:8080/login?continue=1&ajax=commit-login",
	     [login => 'root', password => $password, locale => 'en_US' ];

	my $resp = $self->{ua}->request($req);

	my $content = $resp->{_content};
	my ($name,$value) = ($content =~ /form_update_cookie\("([^"]*)","([^"]*)"\)/);
	$self->{session}=$value;
}

sub put_key{
	my $self = shift;
	my $put_key = POST "https://$self->{host}:8080/root?ajax=ui-key-add",
	    Cookie =>	"session=$self->{session}",
	    Content_Type => 'form-data',
	    Content      => [ key_file => ["$ENV{HOME}/.ssh/id_rsa.pub"] ];


	$self->{ua}->request($put_key);
}

sub dhcp{
	my $self = shift;
	my $daemon = shift;
	my $iface = shift;
	my $start = shift;
	my $end = shift;
	my $dns = shift;
	my $search = shift;
	my $gw = shift;

	$daemon=$daemon?'#t':'#f';
	my $dhcp = POST "https://$self->{host}:8080/dhcp?ajax=ui-general-write",
	    Cookie  =>	"session=$self->{session}",
	    Content => [ daemon => $daemon,
		         iface => $iface,
			 ip_start => $start,
			 ip_end => $end,
			 client_time => 3600,
			 client_dns => $dns,
			 client_search => $search,
			 client_gw => $gw
		    ];


	$self->{ua}->request($dhcp);
}

sub domain{
	my $self = shift;
	my $domain = shift;

	my $req = POST "https://$self->{host}:8080/net-domain?ajax=ui-write",
	    Cookie  =>	"session=$self->{session}",
	    Content => [ domain => $domain,
		         master => '#t',
		    ];


	my $resp = $self->{ua}->request($req);
	my $content = $resp->{_content};
	print $content if $content =~ /Error/;
}

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

Alterator::Automate - Perl extension for automate simple configuration on 
alterator-powered wed server

=head1 SYNOPSIS

  use Alterator::Automate;

  $aa = Alterator::Automate->new($ip);

# auth with password '123'
  $aa->auth('123');
# put ssh key
  $aa->put_key();


=head1 DESCRIPTION

Blah blah blah.

=head1 AUTHOR

Anton V. Boyarshinov, E<lt>boyarsh@altlinux.orgE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2011 by Anton V. Boyarshinov

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.12.3 or,
at your option, any later version of Perl 5 you may have available.


=cut
